package web.controleurs;

import java.io.IOException;

import ejb.sessions.* ;
import ejb.entites.* ;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


@WebServlet(value={"rechCompte","afficherCompte"})
public class Controleur extends HttpServlet {
  private static final long serialVersionUID = 1L;
  
  @javax.ejb.EJB private ServiceBanqueLocal service ;
  
  public Controleur() {}
  
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    String url = request.getRequestURL().toString();
	String maVue ="/rechCompte.html"; // vue par défaut
	if (url.endsWith("/rechCompte")) {
		maVue ="/rechCompte.html"; // rien d'autre à faire
	} else if (url.endsWith("/afficherCompte")) {
	  maVue = "/afficherCompte.jsp"; 	
	  int numeroCompte=Integer.parseInt(request.getParameter("numeroCompte")) ;
	  Compte compte ;
      try {
		compte= service.getCompte(numeroCompte);
		java.util.Collection<LigneAction> l_la =  service.getActionsAchetees(numeroCompte);
		request.setAttribute("listeLA", l_la);
	} catch (CompteInconnuException e) {
		compte=null ;
	}
	  request.setAttribute("compte",compte) ;
	  
	}
	RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(maVue);
    dispatcher.forward(request,response);
  }
}
